#Region "Copyright Syncfusion Inc. 2001 - 2005"
'
'  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
'
'  Use of this code is subject to the terms of our license.
'  A copy of the current license can be obtained at any time by e-mailing
'  licensing@syncfusion.com. Re-distribution in any form is strictly
'  prohibited. Any infringement will be prosecuted under applicable laws. 
'
#End Region


Imports Microsoft.VisualBasic
Imports System
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports Syncfusion.Pdf
Imports Syncfusion.Pdf.Shared
Imports System.IO

Namespace EssentialPDFSamples
	''' <summary>
	''' Summary description for Form1.
	''' </summary>
	Public Class Form1 : Inherits System.Windows.Forms.Form
		Private WithEvents button1 As System.Windows.Forms.Button
		Private label1 As System.Windows.Forms.Label

		''' <summary>
		''' Required designer variable.
		''' </summary>
		Private components As System.ComponentModel.Container = Nothing

		Public Sub New()
			'
			' Required for Windows Form Designer support
			'
			InitializeComponent()
			'
			' TODO: Add any constructor code after InitializeComponent call
			'
		End Sub

		''' <summary>
		''' Clean up any resources being used.
		''' </summary>
		Protected Overrides Overloads Sub Dispose(ByVal disposing As Boolean)
			If disposing Then
				If Not components Is Nothing Then
					components.Dispose()
				End If
			End If
			MyBase.Dispose(disposing)
		End Sub

		#Region "Windows Form Designer generated code"
		''' <summary>
		''' Required method for Designer support - do not modify
		''' the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
			Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
			Me.button1 = New System.Windows.Forms.Button()
			Me.label1 = New System.Windows.Forms.Label()
			Me.SuspendLayout()
			' 
			' button1
			' 
			Me.button1.Anchor = (System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right)
			Me.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat
			Me.button1.Image = (CType(resources.GetObject("button1.Image"), System.Drawing.Bitmap))
			Me.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight
			Me.button1.Location = New System.Drawing.Point(464, 72)
			Me.button1.Name = "button1"
			Me.button1.TabIndex = 0
			Me.button1.Text = "PDF"
'			Me.button1.Click += New System.EventHandler(Me.button1_Click);
			' 
			' label1
			' 
			Me.label1.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) Or System.Windows.Forms.AnchorStyles.Right)
			Me.label1.Font = New System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, (CByte(0)))
			Me.label1.Name = "label1"
			Me.label1.Size = New System.Drawing.Size(544, 56)
			Me.label1.TabIndex = 1
			Me.label1.Text = "Clicking the button below will result in a new PDF document being generated using Essential PDF.  At the end of the document generation, an option will be provided to view the generated PDF file. Please note that you need to have a PDF viewer installed in order to view the generated PDF file."
			' 
			' Form1
			' 
			Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
			Me.ClientSize = New System.Drawing.Size(544, 102)
			Me.Controls.AddRange(New System.Windows.Forms.Control() { Me.label1, Me.button1})
			Me.Icon = (CType(resources.GetObject("$this.Icon"), System.Drawing.Icon))
			Me.Name = "Form1"
			Me.Text = "Essential PDF Sample"
			Me.ResumeLayout(False)

		End Sub
		#End Region

		''' <summary>
		''' The main entry point for the application.
		''' </summary>
		<STAThread> _
		Shared Sub Main()
			Application.Run(New Form1())
		End Sub

		Private Sub button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles button1.Click

			Dim doc As PDFDocument = New PDFDocument()
		
			AddHeader(doc,"Essential PDF Demo","HeaderAndFooter Demo Sample")
			AddFooter(doc, False)
			
			doc.Save("Sample.pdf")

			'Message box confirmation to view the created PDF document.
			If MessageBox.Show ("Do you want to view the PDF file?", "PDF File Created", MessageBoxButtons.YesNo, MessageBoxIcon.Information) = DialogResult.Yes Then
				'Launching the PDF file using the default Application.[Acrobat Reader]
				System.Diagnostics.Process.Start("Sample.pdf")
				Me.Close()
			Else
				' Exit
				Me.Close()
			End If
		End Sub

		Private Sub AddHeader(ByVal doc As PDFDocument, ByVal title As String, ByVal description As String)
			If doc Is Nothing Then
				Throw New ArgumentNullException("doc")
			End If

			If title Is Nothing Then
				Throw New ArgumentNullException("title")
			End If

			Dim offset As Integer = 10

			' Last version
			Dim header As PDFTemplateArea = doc.Templates.Add(New SizeF(doc.LastPage.DrawingWidth, 80))
			header.Dock = PDFDockStyle.Top
			Dim font As IPDFFont = doc.Fonts.Add(FontBaseFamily.HelveticaBold)
			font.Size = 24
			Dim doubleHeight As Single = font.Height * 2
            Dim activeColor As Color = Color.FromArgb(44, 71, 120)

			' add logo
			Dim props As IPDFGraphicState = doc.CreateGraphicState()
			Dim imageSize As SizeF = New SizeF(100,50)
			Dim imageLocation As PointF = New PointF(doc.LastPage.DrawingWidth - imageSize.Width, 15)
			props.Padding = New PDFPadding(offset, offset, 0, 0)


			' add title tag
			props = doc.CreateGraphicState()
			props.TextAlignment = TextAlignment.Center
            props.ForeColor = New PDFColor(activeColor)
			'props.Scale( 0.8f, 0.7f );
			font.Size -= 4
			props.Padding = New PDFPadding(offset * 2, 0, CInt(imageSize.Width), 0)
			header.Graphics.DrawMultiText(offset, 5, doc.LastPage.DrawingWidth, font.Height, title, font, props)

			Dim headerSize As SizeF
			' add description tag
			If Not description Is Nothing AndAlso description.Length > 0 Then
				headerSize = header.Size
				font = doc.Fonts.Add(FontBaseFamily.HelveticaOblique)
				font.Size = 8
				props = doc.CreateGraphicState()
				props.TextAlignment = TextAlignment.Left
				props.Padding = New PDFPadding(offset, 0, 0, 0)
                props.ForeColor = New PDFColor(Color.Gray)
				header.Graphics.DrawMultiText(0, 50, doc.LastPage.DrawingWidth, font.Height, description, font, props)
			End If

			' add border effect
			Dim width As Single = doc.LastPage.DrawingWidth

			headerSize = header.Size
			headerSize.Height -= 10
			activeColor = Color.FromArgb(139, 164, 204)

			props = doc.CreateGraphicState()
            props.ForeColor = New PDFColor(activeColor)
			header.Graphics.DrawLine(0, 0, width, 0)
			header.Graphics.DrawLine(0, headerSize.Height, width, headerSize.Height)

			props = doc.CreateGraphicState()
			props.LineWidth = 2
            props.ForeColor = New PDFColor(activeColor)
			header.Graphics.DrawLine(0, 2, width, 2, props)
			header.Graphics.DrawLine(0, headerSize.Height - 2, width, headerSize.Height - 2, props)

			header.Graphics.DrawLine(0, 5, width, 5)
			header.Graphics.DrawLine(0, headerSize.Height - 5, width, headerSize.Height - 5)

			doc.Templates.Header = header
		End Sub

		Private Sub AddFooter(ByVal doc As PDFDocument, ByVal isLeftRightBarPresents As Boolean)
			If doc Is Nothing Then
				Throw New ArgumentNullException("doc")
			End If

			Dim footer As PDFTemplateArea = doc.Templates.Add(New SizeF(doc.LastPage.DrawingWidth, 40))

			Dim font As IPDFFont = doc.Fonts.Add(FontBaseFamily.HelveticaBold)
			font.Size = 10
            Dim text As String = "Copyright 2005 - Page #p;of #P;"
			Dim size As SizeF = footer.Graphics.MeasureString(text, font)
			Dim bounds As RectangleF = New RectangleF(0, 15, footer.Size.Width, footer.Size.Height)
			Dim props As IPDFGraphicState = doc.CreateGraphicState()
			props.TextAlignment = TextAlignment.Right
			props.BreakBehavior = AutoBreakBehavior.Cropping

			footer.Graphics.DrawMultiText(bounds, text, font, props)

			props = doc.CreateGraphicState()
            props.ForeColor = New PDFColor(Color.Gray)
			Dim textFont As IPDFFont = doc.Fonts.Add(FontBaseFamily.HelveticaOblique)
			textFont.Size = 8
			props.BreakBehavior = AutoBreakBehavior.Cropping

			Dim width As Single = doc.LastPage.DrawingWidth

			footer.Graphics.DrawText(8, 15, "Syncfusion Inc. PDF Generation Example.", textFont, props)

			' add border effect on demand
			If isLeftRightBarPresents Then
				Dim footerSize As SizeF = footer.Size
				footerSize.Height -= 10

				Dim activeColor As Color = Color.FromArgb(139, 164, 204)

				props = doc.CreateGraphicState()
                props.ForeColor = New PDFColor(activeColor)
				footer.Graphics.DrawLine(0, 0, width, 0)
				footer.Graphics.DrawLine(0, footerSize.Height, width, footerSize.Height)

				props = doc.CreateGraphicState()
				props.LineWidth = 2
                props.ForeColor = New PDFColor(activeColor)
				footer.Graphics.DrawLine(0, 2, width, 2, props)
				footer.Graphics.DrawLine(0, footerSize.Height - 2, width, footerSize.Height - 2, props)

				footer.Graphics.DrawLine(0, 5, width, 5)
				footer.Graphics.DrawLine(0, footerSize.Height - 5, width, footerSize.Height - 5)
			End If

			doc.Templates.Footer = footer
		End Sub

	End Class
End Namespace
